  <html>
    <head>
      <script type="text/javascript" src="../../scripts/hotdrink.js"></script>
      <script>
        let whap = hd.component`
          component whap {
            var A=100, w, h, p;
            constraint pwh {
              m1(w, h -> p) => 2*(w+h);
              m2(p, w -> h) => p/2 - w;
              m3(p, h -> w) => p/2 - h;
            }
            constraint Awh {
              n1(w, h -> A) => w*h;
              n2(A -> w, h) => [Math.sqrt(A), Math.sqrt(A)];
            }
          }
          `
        var cs = new hd.ConstraintSystem();
        cs.addComponent(whap);
        cs.update();
          function textBinder(box, v) {
            v.value.subscribe(val => { if ('value' in val) box.value = val.value; });
            box.addEventListener('input', () => { v.value.set(box.value); });
          };
          window.addEventListener('load', function() {
              textBinder(document.getElementById("A"), whap.vs.A);
              textBinder(document.getElementById("w"), whap.vs.w);
              textBinder(document.getElementById("h"), whap.vs.h);
              textBinder(document.getElementById("p"), whap.vs.p);
          });
      </script>
    </head>
    <body>
          <style type="text/css">
            fieldset#whap-gui { background-color: white }
            fieldset#whap-gui input[type="text"] { width: 8ex; margin-right: 2ex }
            fieldset#whap-gui label { display:inline-block; width: 2ex; } 
            .vertical-middle { display:inline-block; vertical-align:middle; } 
          </style>
        <fieldset id="whap-gui">
          <label for="A">A</label><input id="A" type="text"></input>
      
          <span class="vertical-middle">
            <label for="w">w</label><input id="w" type="text"/></br>
            <label for="h">h</label><input id="h" type="text"/>
          </span>
      
          <label for="p">p</label><input id="p" type="text"/>
        </fieldset>
    </body>
  </html>
